# coingecko_dart

A Dart/Flutter Wrapper for the CoinGecko API (V3).

* USAGE:
```
    CoinGeckoApi apiInstance = CoinGeckoApi();
    CoinGeckoResult pingResult = apiInstance.ping();
    CoinGeckoResult<List<Coin>> coinListResult = apiInstance.listCoins();
```

Methods implemented so far:
```
    ping()                        -> /ping
```
SIMPLE
--------
```    
    simplePrice()                 -> /simple/price
    simpleTokenPrice()            -> /simple/token_price/{id}
    simpleSupportedVsCurrencies() -> /simple/supported_vs_currencies
```
COINS
--------
```   
    listCoins()                   -> /coins/list
    getCoinMarkets()              -> /coins/markets
    getCoinData()                 -> /coins/{id}
    getCoinTickers()              -> /coins/{id}/tickers
    getCoinHistory()              -> /coins/{id}/history
    getCoinMarketChart()          -> /coins/{id}/market_chart
    getCoinMarketChartRanged()    -> /coins/{id}/market_chart/range
```
CONTRACT
--------
```
    getContractTokenData()        -> /coins/{id}/contract/{contract_address}
    getContractMarketChart()      -> /coins/{id}/contract/{contract_address}/market_chart
    getContractMarketChartRanged()-> /coins/{id}/contract/{contract_address}/market_chart/range
```
EXCHANGES
--------
```
    getExchanges()                -> /exchanges
    getExchangeRatesBtc()         -> /exchange_rates
```
TRENDING
-------
```
    getSearchTrending()           -> /search/trending
```
GLOBAL
-------
```
    getGlobalCoins()              -> /global
    getGlobalDefi()               -> /global/decentralized_finance_defi
```

I'll now focus on adding better documentation for all this before implementing beta api functionality.
(Apr 18 21)